#include <bits/stdc++.h>

#define maxn 200002
#define maxa 100000001;

int a[maxn];

using namespace std;

int main() {
	int n;
	cin >> n;
	bool stablo[n + 1][n + 1];
	memset(stablo, 0, sizeof(stablo));
	for(int i = 1; i <= n; i++) {
		cin >> a[i];
	} 
	
	for(int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		stablo[u][v] = true;
		stablo[v][u] = true;
	}
	
	long long min = maxa;
	int mini = 1;
	for(int i = 1; i <= n; i++) {
		if(a[i] < min) min = a[i]; mini = i;
	}
	cout << min << "\n1\n" << mini << "\n0";
	return 0;
}